#!/bin/sh
clear
echo
echo " oooooooooo.           ooo        ooooo   .oooooo.   ooooooooo.   oooooooooooo"
echo " \`888'   \`Y8b          \`88.       .888'  d8P'  \`Y8b  \`888   \`Y88. \`888'     \`8"
echo "  888      888          888b     d'888  888      888  888   .d88'  888"
echo "  888      888          8 Y88. .P  888  888      888  888ooo88P'   888oooo8"
echo "  888      888 8888888  8  \`888'   888  888      888  888\`88b.     888    "
echo "  888     d88'          8    Y     888  \`88b    d88'  888  \`88b.   888       o"
echo " o888bood8P'           o8o        o888o  \`Y8bood8P'  o888o  o888o o888ooooood8"
echo
echo ===============================
echo   D-MORE インストーラへようこそ！
echo ===============================
echo 
echo KSL, Kernels and Systems Lab, Kourai Laboratory
echo D-MORE, Domain-R by kawasho
echo Domain-M by U_SAN,
echo Installer by kawasho
echo 
echo Xen 4.3.2 をサポートしています。
echo バージョンが異なる場合は必ず4.3.2との間に
echo 変更が行われていないか確認してください。

if [ "$1" = "" ]; then
	echo 
	echo Xenのソースディレクトリへのパスを入力してください。
	echo 例 ~/workspace/xen-4.3.2
	echo Tip: 0 または y と入力すると，/p/workspace/xen-4.3.2に設定します。
	read domainR_path
fi

if [ "$domainR_path" = '0' -o "$domainR_path" = 'y' -o "$1" != "" ]; then
    domainR_path="/p/workspace/xen-4.3.2"
    echo $domainR_path が代入されます。
fi

# ここにインストーラが入っているディレクトリのパスを入れてください
installer_path="/p/workspace/domainR-4.3.2"

clear
echo 
echo ファイルの存在を検査します。
echo 

ls ${installer_path}/common/xenctrl.h 
ls ${domainR_path}/tools/libxc/xenctrl.h

ls ${installer_path}/domainr/xc.c 
ls ${domainR_path}/tools/python/xen/lowlevel/xc/xc.c
ls ${installer_path}/domainr/xc_domain.c 
ls ${domainR_path}/tools/libxc/xc_domain.c
ls ${installer_path}/domainr/xc_domain_restore.c 
ls ${domainR_path}/tools/libxc/xc_domain_restore.c
ls ${installer_path}/domainr/xc_domain_save.c 
ls ${domainR_path}/tools/libxc/xc_domain_save.c
ls ${installer_path}/domainr/xc_private.c 
ls ${domainR_path}/tools/libxc/xc_private.c
ls ${installer_path}/domainr/sched.h 
ls ${domainR_path}/xen/include/xen/sched.h
ls ${installer_path}/domainr/domain.c 
ls ${domainR_path}/xen/common/domain.c
ls ${installer_path}/domainr/domctl.c 
ls ${domainR_path}/xen/common/domctl.c
ls ${installer_path}/domainr/domctl.h 
ls ${domainR_path}/xen/include/public/domctl.h
ls ${installer_path}/domainr/XendConfig.py 
ls ${domainR_path}/tools/python/xen/xend/XendConfig.py
ls ${installer_path}/domainr/XendCheckpoint.py 
ls ${domainR_path}/tools/python/xen/xend/XendCheckpoint.py
ls ${installer_path}/domainr/create.py
ls ${domainR_path}/tools/python/xen/xm/create.py
ls ${installer_path}/domainr/minios.mk
ls ${domainR_path}/extras/mini-os/minios.mk
ls ${installer_path}/domainr/mm.c
ls ${domainR_path}/xen/arch/x86/mm.c
ls ${installer_path}/domainr/paging.c
ls ${domainR_path}/xen/arch/x86/mm/paging.c
ls ${installer_path}/domainr/dummy.h
ls ${domainR_path}/xen/include/xsm/dummy.h

ls ${installer_path}/d-more/xc_evtchn.c 
ls ${domainR_path}/tools/libxc/xc_evtchn.c
ls ${installer_path}/d-more/xc_linux_osdep.c
ls ${domainR_path}/tools/libxc/xc_linux_osdep.c
ls ${installer_path}/d-more/xenctrlosdep.h
ls ${domainR_path}/tools/libxc/xenctrlosdep.h
ls ${installer_path}/d-more/evtchn.h
ls ${domainR_path}/tools/include/xen-sys/Linux/evtchn.h
ls ${installer_path}/d-more/event_channel.c
ls ${domainR_path}/xen/common/event_channel.c
ls ${installer_path}/d-more/event_channel.h
ls ${domainR_path}/xen/include/public/event_channel.h
ls ${installer_path}/d-more/xen_machine_pv.c
ls ${domainR_path}/tools/qemu-xen-traditional/hw/xen_machine_pv.c

echo
echo "検査結果はコピー元，コピー先の順に表示しています。"
echo "(新規インストールファイルは存在しない旨表示されますが，正常です。)"

if [ "$1" = "" ]; then
	echo 問題なければ開始できますが，開始前にもう一度確認してください。
	echo 
	echo 開始して宜しいですか？ [y/n]
	read ANS
	clear
else
	ANS='y'
fi

if [ $ANS = 'y' -o $ANS = 'yes' ]; then
	echo 
	echo [1/2] バックアップを作成します。
	echo 
	TODAY=`date '+%F-%H%M'`
	DIR="${installer_path}/backups/backup_${TODAY}"
	mkdir -v $DIR
	
	cp -v ${domainR_path}/tools/libxc/xenctrl.h $DIR

	cp -v ${domainR_path}/tools/python/xen/lowlevel/xc/xc.c $DIR
	cp -v ${domainR_path}/tools/libxc/xc_domain.c $DIR
	cp -v ${domainR_path}/tools/libxc/xc_domain_restore.c $DIR
	cp -v ${domainR_path}/tools/libxc/xc_domain_save.c $DIR
	cp -v ${domainR_path}/tools/libxc/xc_private.c $DIR
	cp -v ${domainR_path}/xen/include/xen/sched.h $DIR
	cp -v ${domainR_path}/xen/common/domain.c $DIR
	cp -v ${domainR_path}/xen/common/domctl.c $DIR
	cp -v ${domainR_path}/xen/include/public/domctl.h $DIR
	cp -v ${domainR_path}/tools/python/xen/xend/XendConfig.py $DIR
	cp -v ${domainR_path}/tools/python/xen/xend/XendCheckpoint.py $DIR
	cp -v ${domainR_path}/tools/python/xen/xm/create.py $DIR
	cp -v ${domainR_path}/extras/mini-os/minios.mk $DIR
	cp -v ${domainR_path}/xen/arch/x86/mm.c $DIR
	cp -v ${domainR_path}/xen/arch/x86/mm/paging.c $DIR
	cp -v ${domainR_path}/xen/include/xsm/dummy.h $DIR

	cp -v ${domainR_path}/tools/libxc/xc_evtchn.c $DIR
	cp -v ${domainR_path}/tools/libxc/xc_linux_osdep.c $DIR
	cp -v ${domainR_path}/tools/libxc/xenctrlosdep.h $DIR
	cp -v ${domainR_path}/tools/include/xen-sys/Linux/evtchn.h $DIR
	cp -v ${domainR_path}/xen/common/event_channel.c $DIR
	cp -v ${domainR_path}/xen/include/public/event_channel.h $DIR
	cp -v ${domainR_path}/tools/qemu-xen-traditional/hw/xen_machine_pv.c $DIR

	echo 
	echo [2/2] インストールを開始します。
	echo 
	
	cp -v ${installer_path}/common/xenctrl.h ${domainR_path}/tools/libxc/xenctrl.h

	cp -v ${installer_path}/domainr/xc.c ${domainR_path}/tools/python/xen/lowlevel/xc/xc.c
	cp -v ${installer_path}/domainr/xc_domain.c ${domainR_path}/tools/libxc/xc_domain.c
	cp -v ${installer_path}/domainr/xc_domain_restore.c ${domainR_path}/tools/libxc/xc_domain_restore.c
	cp -v ${installer_path}/domainr/xc_domain_save.c ${domainR_path}/tools/libxc/xc_domain_save.c
	cp -v ${installer_path}/domainr/xc_private.c ${domainR_path}/tools/libxc/xc_private.c
	cp -v ${installer_path}/domainr/sched.h ${domainR_path}/xen/include/xen/sched.h
	cp -v ${installer_path}/domainr/domain.c ${domainR_path}/xen/common/domain.c
	cp -v ${installer_path}/domainr/domctl.c ${domainR_path}/xen/common/domctl.c
	cp -v ${installer_path}/domainr/domctl.h ${domainR_path}/xen/include/public/domctl.h
	cp -v ${installer_path}/domainr/XendConfig.py ${domainR_path}/tools/python/xen/xend/XendConfig.py
	cp -v ${installer_path}/domainr/XendCheckpoint.py ${domainR_path}/tools/python/xen/xend/XendCheckpoint.py
	cp -v ${installer_path}/domainr/create.py ${domainR_path}/tools/python/xen/xm/create.py
	cp -v ${installer_path}/domainr/minios.mk ${domainR_path}/extras/mini-os/minios.mk
	cp -v ${installer_path}/domainr/mm.c ${domainR_path}/xen/arch/x86/mm.c
	cp -v ${installer_path}/domainr/paging.c ${domainR_path}/xen/arch/x86/mm/paging.c
	cp -v ${installer_path}/domainr/dummy.h ${domainR_path}/xen/include/xsm/dummy.h
	
	cp -v ${installer_path}/d-more/xc_evtchn.c ${domainR_path}/tools/libxc/xc_evtchn.c
	cp -v ${installer_path}/d-more/xc_linux_osdep.c ${domainR_path}/tools/libxc/xc_linux_osdep.c
	cp -v ${installer_path}/d-more/xenctrlosdep.h ${domainR_path}/tools/libxc/xenctrlosdep.h
	cp -v ${installer_path}/d-more/evtchn.h ${domainR_path}/tools/include/xen-sys/Linux/evtchn.h
	cp -v ${installer_path}/d-more/event_channel.c ${domainR_path}/xen/common/event_channel.c
	cp -v ${installer_path}/d-more/event_channel.h ${domainR_path}/xen/include/public/event_channel.h
	cp -v ${installer_path}/d-more/xen_machine_pv.c ${domainR_path}/tools/qemu-xen-traditional/hw/xen_machine_pv.c

	echo 
	echo インストールが完了しました！
else
	echo キャンセルされました。
fi
